Index: LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/ord_coordm.F
===================================================================
--- LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/ord_coordm.F	(revision 497)
+++ LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/ord_coordm.F	(revision 497)
@@ -0,0 +1,107 @@
+       SUBROUTINE ord_coordm ( nmax, xi, xo, jjm, jmods, decrois )
+
+c   ....  Auteur :  P. Le Van  .... 
+
+c   ... Reordonne eventuellement les coordonnees de la grille modele ...
+c
+       IMPLICIT NONE
+
+c    .....  Arguments  en entree  .....
+
+       INTEGER nmax,jjm
+       REAL xi(nmax)
+
+c    .....  Arguments  en sortie  .....
+c
+       REAL xo(nmax+1) 
+       LOGICAL decrois
+       INTEGER jmods
+
+c    .... Variables  locales  ....
+
+       REAL xscr(nmax)
+       INTEGER i
+       REAL pi, degres, chmin, chmax,mult
+c
+       DO i = 1, nmax 
+        xo(i) = xi(i)
+       ENDDO
+
+       mult = 1.
+       IF( xo(1).GT.xo(nmax) )  mult = - 1.
+       IF( nmax.EQ.jjm    ) jmods = nmax +1
+       IF( nmax.EQ.jjm +1 ) jmods = nmax -1 
+     
+       pi     = 2.*ASIN(1.)
+       degres = 180./pi
+       decrois = .FALSE.
+
+       CALL minmax(nmax,xo(1),chmin,chmax)
+
+       IF(chmax.LT.6.5 )  THEN
+          DO i = 1,nmax
+           xo(i) = xo(i) * degres 
+          ENDDO
+       ENDIF
+
+       IF( nmax.EQ.jjm )   THEN
+         IF( xo(1).GT.xo(nmax) )   THEN
+           DO i = 1, nmax 
+            xscr(i) = xo(i)
+           ENDDO
+           DO i = 1, nmax 
+            xo(i+1) = xscr(i)
+           ENDDO
+            xo (   1    ) =   90.
+         ELSE
+            xo ( nmax+1 ) =   90.
+         ENDIF
+       ELSE
+          IF( nmax.NE.jjm +1 )   THEN
+             PRINT *,'  Dans la routine ord_coordm , l argument nmax '
+             PRINT *,'  n est pas egal a jjm ni a jjm +1 . Corriger !'
+             CALL ABORT
+          ELSE
+            IF( ABS( xo(1)+ mult * 90.).GT.0.01 )  THEN
+              PRINT *,' Avec nmax =',nmax,'on devrait avoir des',
+     ,    ' ordonnees = 90. deg pour j=1 ou jjm+1 ! '
+             CALL ABORT
+            ELSE
+               IF( xo(1).LT.xo(nmax) )  THEN
+                 DO i = 1, nmax
+                  xscr(i) = xo(i)
+                 ENDDO
+                 DO i = 1, nmax -1
+                  xo(i) = xscr(i+1)
+                 ENDDO
+               ENDIF
+            ENDIF
+          ENDIF
+       ENDIF
+
+       IF ( xo(2).LT.xo(1) ) decrois =.TRUE.
+
+       DO i = 3, nmax 
+
+        IF(decrois.AND.xo(i).GT.xo(i-1) ) THEN
+         PRINT 1
+         CALL ABORT 
+        ENDIF
+        IF(.NOT.decrois.AND.xo(i).LT.xo(i-1) ) THEN
+         PRINT 1
+         CALL ABORT
+        ENDIF
+
+       ENDDO
+        
+       IF( decrois )  THEN
+         CALL sort(jmods,xo(1))
+       ENDIF
+
+
+1      FORMAT(5x,' Incoherence dans les valeurs des latitudes de la ',
+     ,  'grille du modele ')
+2      FORMAT(1x,8f8.2)
+
+       RETURN
+       END
Index: LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/paramet.h
===================================================================
--- LMDZ.3.3/branches/LF/libf/dyn3d/paramet.h	(revision 3)
+++ LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/paramet.h	(revision 497)
@@ -7,5 +7,6 @@
       INTEGER jcfil,jcfllm
 
-      PARAMETER( iip1= iim+1, iip2= iim+2, iip3= iim+3, jjp1= jjm+1 )
+      PARAMETER( iip1= iim+1-1/iim,iip2=iim+2,iip3=iim+3
+     s    ,jjp1=jjm+1-1/jjm)
       PARAMETER( llmp1 = llm+1,  llmp2 = llm+2, llmm1 = llm-1 )
       PARAMETER( kftd  = iim/2 -ndm )
Index: LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/pres2lev.F
===================================================================
--- LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/pres2lev.F	(revision 497)
+++ LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/pres2lev.F	(revision 497)
@@ -0,0 +1,77 @@
+c $Header$
+c******************************************************
+      SUBROUTINE   pres2lev(varo,varn,lmo,lmn,po,pn,
+     %                      ni,nj)
+c
+c interpolation lineaire pour passer
+c a une nouvelle discretisation verticale pour
+c les variables de GCM
+c Francois Forget (01/1995)
+c 
+c MOdif remy roca 12/97 pour passer de pres2sig
+c**********************************************************
+
+      IMPLICIT NONE
+
+c   Declarations:
+c ==============
+c
+c  ARGUMENTS
+c  """""""""
+
+       INTEGER lmo ! dimensions ancienne couches (input)
+       INTEGER lmn ! dimensions nouvelle couches (input)
+       INTEGER lmomx ! dimensions ancienne couches (input)
+       INTEGER lmnmx ! dimensions nouvelle couches (input)
+
+       parameter(lmomx=10000,lmnmx=10000)
+
+        real po(lmo)! niveau de pression en millibars
+        real pn(ni,nj,lmn) ! niveau de pression en pascals
+
+       INTEGER i,j,Nhoriz,ni,nj ! nombre de point horizontale (input)
+
+       REAL varo(ni,nj,lmo) ! var dans l'ancienne grille (input)
+       REAL varn(ni,nj,lmn) ! var dans la nouvelle grille (output)
+
+       real zvaro(lmomx),zpo(lmomx)
+
+c Autres variables
+c """"""""""""""""
+       INTEGER n, ln ,lo 
+       REAL coef
+
+c run
+c ====
+        do i=1,ni
+        do j=1,nj
+c a chaque point de grille correspond un nouveau sigma old
+c qui vaut pres(l)/ps(i,j)
+           do lo=1,lmo
+              zpo(lo)=po(lmo+1-lo)
+              zvaro(lo)=varo(i,j,lmo+1-lo)
+           enddo
+        
+           do ln=1,lmn
+              if (pn(i,j,ln).ge.zpo(1))then
+                 varn(i,j,ln) =  zvaro(1)
+              else if (pn(i,j,ln).le.zpo(lmo)) then
+                 varn(i,j,ln) =  zvaro(lmo)
+              else
+                 do lo=1,lmo-1 
+                    if ( (pn(i,j,ln).le.zpo(lo)).and.
+     &                 (pn(i,j,ln).gt.zpo(lo+1)) )then
+                       coef=(pn(i,j,ln)-zpo(lo))
+     &                 /(zpo(lo+1)-zpo(lo))
+                       varn(i,j,ln)=zvaro(lo)
+     &                 +coef*(zvaro(lo+1)-zvaro(lo))
+c       print*,'pn(',ln,')=',pn(i,j,ln),varn(i,j,ln)
+                    end if
+                 enddo           
+              endif
+           enddo
+
+        enddo
+        enddo
+      return
+      end    
Index: LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/read_dstoke.F
===================================================================
--- LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/read_dstoke.F	(revision 497)
+++ LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/read_dstoke.F	(revision 497)
@@ -0,0 +1,78 @@
+c $Header$
+            subroutine read_dstoke(irec,zdtvr,ziadvtrac,ziadvtrac2)
+
+
+            IMPLICIT NONE
+
+#include "netcdf.inc"
+#include "dimensions.h"
+#include "paramet.h"
+#include "comgeom.h"
+#include "comvert.h"
+
+	
+	integer ncidfd
+        save ncidfd
+        integer variddt,varididvt,varididvp
+        save variddt,varididvt,varididvp
+        real*4 dtv(1,1,1),adv2(1,1,1),adv(1,1,1)
+        real zdtvr,ziadvtrac,ziadvtrac2
+        integer status,irec
+        real rcode
+        INTEGER epais(2), debut(2)
+	
+	if (irec .eq. 0) then
+	
+	ncidfd=NCOPN('defstoke.nc',NCNOWRIT,rcode)
+
+        variddt=NCVID(ncidfd,'dtvr',rcode)
+        print*,'ncidfd,variddt',ncidfd,variddt
+
+        varididvt=NCVID(ncidfd,'istdyn',rcode)
+        print*,'ncidfd,varididvt',ncidfd,varididvt
+	
+	varididvp=NCVID(ncidfd,'istphy',rcode)
+        print*,'ncidfd,varididvp',ncidfd,varididvp
+
+c lecture de zdtvr et ziadvtrac
+	
+	epais(1) = 1
+        epais(2) = 1
+        debut(1) = 1
+        debut(2) = 1
+
+#ifdef NC_DOUBLE
+        status=NF_GET_VARA_DOUBLE(ncidfd,variddt,debut,epais,dtv)
+#else
+        status=NF_GET_VARA_REAL(ncidfd,variddt,debut,epais,dtv)
+#endif
+        zdtvr=dtv(1,1,1)
+
+#ifdef NC_DOUBLE
+        status=NF_GET_VARA_DOUBLE(ncidfd,varididvt,debut,epais,adv)
+#else
+        status=NF_GET_VARA_REAL(ncidfd,varididvt,debut,epais,adv)
+#endif
+        ziadvtrac= adv(1,1,1)
+	
+#ifdef NC_DOUBLE
+	status=NF_GET_VARA_DOUBLE(ncidfd,varididvp,debut,epais,adv2)
+#else
+	status=NF_GET_VARA_REAL(ncidfd,varididvp,debut,epais,adv2)
+#endif
+        ziadvtrac2= adv2(1,1,1)
+
+        write(*,*) 'ds read_dstoke zdtvr = ', zdtvr
+        write(*,*) 'ds read_dstoke ziadvtrac = ', ziadvtrac
+        write(*,*) 'ds read_dstoke ziadvtrac2 = ', ziadvtrac2
+	
+c           status=NF_CLOSE(ncidfd)
+
+        else
+            stop'Pas bon irec ne 0'
+	endif
+	
+	return
+
+	end
+
Index: LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/read_fstoke.F
===================================================================
--- LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/read_fstoke.F	(revision 497)
+++ LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/read_fstoke.F	(revision 497)
@@ -0,0 +1,297 @@
+c $Header$
+	subroutine read_fstoke(irec,
+     . zrec,zim,zjm,zlm,rlonu_dy,rlonv_dy,rlatu_dy,rlatv_dy,
+     . airedy,phis,
+     . masse,pbaru,pbarv,w,teta,phi)
+
+	IMPLICIT NONE
+
+#include "netcdf.inc"
+#include "dimensions.h"
+#include "paramet.h"
+#include "comgeom.h"
+#include "comvert.h"
+	
+      integer nlevnc,irec
+      parameter (nlevnc=19)
+      integer mode,l
+
+	integer imo,jmo,imo1,jmo1,imn,jmn
+	parameter (imn=iim,jmn=jjm,imo=imn/2,jmo=(jmn+1)/2)
+        parameter (imo1=imo+1,jmo1=jmo+1)
+
+      real*4 pbaru(imo1,jmo1,llm),pbarv(imo1,jmo,llm)
+      real*4 teta(imo1,jmo1,llm),phis(imo1,jmo1),phi(imo1,jmo1,llm)
+      real*4 masse(imo1,jmo1,llm),w(imo1,jmo1,llm)
+      real*4 airedy(imo1,jmo1)
+      real*4 rlonu_dy(imo1,jmo1),rlonv_dy(imo1,jmo),
+     . rlatu_dy(imo1,jmo1),rlatv_dy(imo1,jmo)
+      integer*4 ncrec,ncim,ncjm,nclm
+      integer*4 zrec,zim,zjm,zlm
+      integer*4 xid,yid,zid,tid
+      real*4 zdtvr,ziadvtrac
+      real adv(1), dtv(1)
+
+      integer ncidf,ncidfv
+      integer varidpu,varidpv,varidt,varidw,varidps,varidph,varidai
+      integer varidpl,varidm
+      integer varidnlo,varidnla,varidnlov,varidnlav
+      save ncidf,ncidfv
+      save varidpu,varidpv,varidt,varidw,varidps,varidph,varidai
+      save varidpl,varidm
+      save varidnlo,varidnla,varidnlov,varidnlav
+
+      real*4 pl(nlevnc)
+
+      integer start(4),count(4),status
+
+      real rcode
+	
+      character namedim	
+	
+c ---------------------------------------------
+c   Initialisation de la lecture des fichiers
+c ---------------------------------------------
+
+      if (irec .eq. 0) then
+
+            ncidf=NCOPN('fluxstoke.nc',NCNOWRIT,rcode)
+
+            varidps=NCVID(ncidf,'phis',rcode)
+            print*,'ncidf,varidps',ncidf,varidps
+
+            varidpl=NCVID(ncidf,'sig_s',rcode)
+            print*,'ncidf,varidpl',ncidf,varidpl
+	
+	    varidnlo=NCVID(ncidf,'nav_lon',rcode)
+            print*,'ncidf,varidnlo',ncidf,varidnlo
+          
+            varidnla=NCVID(ncidf,'nav_lat',rcode)
+            print*,'ncidf,varidnla',ncidf,varidnla
+	
+            varidai=NCVID(ncidf,'aire',rcode)
+            print*,'ncidf,varidai',ncidf,varidai
+         
+            varidm=NCVID(ncidf,'masse',rcode)
+            print*,'ncidf,varidm',ncidf,varidm
+
+            varidpu=NCVID(ncidf,'pbaru',rcode)
+            print*,'ncidf,varidpu',ncidf,varidpu
+		
+            varidw=NCVID(ncidf,'w',rcode)
+            print*,'ncidf,varidw',ncidf,varidw
+	
+	    varidt=NCVID(ncidf,'teta',rcode)
+            print*,'ncidf,varidt',ncidf,varidt
+ 
+	    varidph=NCVID(ncidf,'phi',rcode)
+            print*,'ncidf,varidph',ncidf,varidph
+	
+	    ncidfv=NCOPN('fluxstokev.nc',NCNOWRIT,rcode)
+
+            varidpv=NCVID(ncidfv,'pbarv',rcode)
+            print*,'ncidfv,varidpv',ncidfv,varidpv
+	
+	    varidnlov=NCVID(ncidfv,'nav_lon',rcode)
+            print*,'ncidf,varidnlov',ncidf,varidnlov
+          
+            varidnlav=NCVID(ncidfv,'nav_lat',rcode)
+            print*,'ncidfv,varidnlav',ncidfv,varidnlav
+	
+
+c ID pour les dimensions
+	
+	    status = nf_inq_dimid(ncidf,'y',yid)
+            status = nf_inq_dimid(ncidf,'x',xid)
+            status = nf_inq_dimid(ncidf,'sig_s',zid) 
+            status = nf_inq_dimid(ncidf,'time_counter',tid)
+
+c lecture des dimensions
+	
+	    status = nf_inq_dim(ncidf,yid,namedim,ncjm)
+            status = nf_inq_dim(ncidf,xid,namedim,ncim)
+            status = nf_inq_dim(ncidf,zid,namedim,nclm)
+            status = nf_inq_dim(ncidf,tid,namedim,ncrec)
+	
+	    zjm=ncjm
+            zim=ncim
+            zlm=nclm
+            zrec=ncrec
+	
+	    write(*,*) 'read_fstoke : zrec = ', zrec
+            write(*,*) 'read_fstoke : zlm = ', zlm
+            write(*,*) 'read_fstoke : zim = ', zim
+            write(*,*) 'read_fstoke : zjm = ', zjm
+
+c niveaux de pression
+        
+#ifdef NC_DOUBLE
+       status=NF_GET_VARA_DOUBLE(ncidf,varidpl,1,zlm,pl)
+#else
+       status=NF_GET_VARA_REAL(ncidf,varidpl,1,zlm,pl)
+#endif
+
+c rlonu,rlonv,rlatu,rlatv
+	
+      start(1)=1
+      start(2)=1
+      start(3)=1
+      start(4)=0
+
+      count(1)=zim
+      count(2)=zjm
+      count(3)=1
+      count(4)=0
+	
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidnlo,start,count,rlonu_dy)
+      status=NF_GET_VARA_DOUBLE(ncidf,varidnla,start,count,rlatu_dy)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidnlo,start,count,rlonu_dy)
+      status=NF_GET_VARA_REAL(ncidf,varidnla,start,count,rlatu_dy)
+#endif
+	
+      start(1)=1
+      start(2)=1
+      start(3)=1
+      start(4)=0
+
+      count(1)=zim
+      count(2)=zjm-1
+      count(3)=1
+      count(4)=0
+
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidfv,varidnlov,start,count,rlonv_dy)
+      status=NF_GET_VARA_DOUBLE(ncidfv,varidnlav,start,count,rlatv_dy)
+#else
+      status=NF_GET_VARA_REAL(ncidfv,varidnlov,start,count,rlonv_dy)
+      status=NF_GET_VARA_REAL(ncidfv,varidnlav,start,count,rlatv_dy)
+#endif
+
+c Lecture de phis et aire
+	
+      start(1)=1
+      start(2)=1
+      start(3)=1
+      start(4)=0
+
+      count(1)=zim
+      count(2)=zjm
+      count(3)=1
+      count(4)=0
+
+c phis
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidps,start,count,phis)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidps,start,count,phis)
+#endif
+
+c aire
+#ifdef NC_DOUBLE
+       status=NF_GET_VARA_DOUBLE(ncidf,varidai,start,count,airedy)
+#else
+       status=NF_GET_VARA_REAL(ncidf,varidai,start,count,airedy)
+#endif
+
+       else 
+
+      print*,'ok1'
+
+c ---------------------
+c   lecture des champs 
+c ---------------------
+
+      print*,'WARNING!!! Il n y a pas de test de coherence'
+      print*,'sur le nombre de niveaux verticaux dans le fichier nc'
+
+      start(1)=1
+      start(2)=1
+      start(3)=1
+      start(4)=irec
+
+      count(1)=zim
+      count(2)=zjm
+      count(3)=zlm
+      count(4)=1
+
+c masse 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidm,start,count,masse)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidm,start,count,masse)
+#endif
+c      print*,'WARNING!!! Correction bidon pour palier a un '
+c      print*,'probleme dans la creation des fichiers nc'
+c      call correctbid(iim,jmo1*nlevnc,masse)
+	print*,'***********Lecture MASSE '
+       call dump2d(imo1,jmo1,masse,'MASSE COUCHE 1')
+c pbaru 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidpu,start,count,pbaru)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidpu,start,count,pbaru)
+#endif
+c      print*,'WARNING!!! Correction bidon pour palier a un '
+c      print*,'probleme dans la creation des fichiers nc'
+c      call correctbid(iim,jmo1*nlevnc,pbaru)
+c      call dump2d(imo1,jmo1,pbaru,'PBARUNC COUCHE 1')
+
+c w 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidw,start,count,w)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidw,start,count,w)
+#endif
+c      print*,'WARNING!!! Correction bidon pour palier a un '
+c      print*,'probleme dans la creation des fichiers nc'
+c      call correctbid(iim,jmo1*nlevnc,w)
+c      call dump2d(imo1,jmo1,w,'WNC COUCHE 1')
+
+c teta 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidt,start,count,teta)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidt,start,count,teta)
+#endif
+c      print*,'WARNING!!! Correction bidon pour palier a un '
+c      print*,'probleme dans la creation des fichiers nc'
+c      call correctbid(iim,jmo1*nlevnc,teta)
+c      call dump2d(imo1,jmo1,teta,'TETANC COUCHE 1')
+
+c phi 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidph,start,count,phi)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidph,start,count,phi)
+#endif
+c      print*,'WARNING!!! Correction bidon pour palier a un '
+c      print*,'probleme dans la creation des fichiers nc'
+c      call correctbid(iim,jmo1*nlevnc,phi)
+c      call dump2d(imo1,jmo1,phi,'PHINC COUCHE 1')
+	
+	count(2) = zjm-1 
+
+c  pbarv
+	print*,'Lecture de pbarv irec=',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidfv,varidpv,start,count,pbarv)
+#else
+      status=NF_GET_VARA_REAL(ncidfv,varidpv,start,count,pbarv)
+#endif
+c      call correctbid(iim,jjm*nlevnc,pbarv)
+	PRINT*,'*******LECTURE DE PBARV******'
+      call dump2d(imo1,jjm,pbarv,'PBARVNC COUCHE 1')
+	print*,'Ok Lecture de pbarv irec=',irec
+      start(3)=irec
+      start(4)=0
+      count(2)=jmo1
+      count(3)=1
+      count(4)=0
+
+	endif
+	print*,'Fin read_fstoke a irec=',irec
+      return
+      end
+
Index: LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/read_fstoke0.F
===================================================================
--- LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/read_fstoke0.F	(revision 497)
+++ LMDZ.3.3/tags/IPSL-CM4_LJ29_OPT/libf/dyn3d/read_fstoke0.F	(revision 497)
@@ -0,0 +1,269 @@
+c $Header$
+	subroutine read_fstoke0(irec,
+     . zrec,zim,zjm,zlm,rlonu_dy,rlonv_dy,rlatu_dy,rlatv_dy,
+     . airedy,phis,
+     . masse,pbaru,pbarv,w,teta,phi)
+
+	IMPLICIT NONE
+
+#include "netcdf.inc"
+#include "dimensions.h"
+#include "paramet.h"
+#include "comgeom.h"
+#include "comvert.h"
+	
+      integer nlevnc,irec
+      parameter (nlevnc=19)
+      integer mode,l
+
+      real*4 pbaru(iip1,jjp1,llm),pbarv(iip1,jjm,llm)
+      real*4 teta(iip1,jjp1,llm),phis(iip1,jjp1),phi(iip1,jjp1,llm)
+      real*4 masse(iip1,jjp1,llm),w(iip1,jjp1,llm)
+      real*4 airedy(iip1,jjp1)
+      real*4 rlonu_dy(iip1,jjp1),rlonv_dy(iip1,jjm),
+     . rlatu_dy(iip1,jjp1),rlatv_dy(iip1,jjm)
+      integer*4 ncrec,ncim,ncjm,nclm
+      integer*4 zrec,zim,zjm,zlm
+      integer*4 xid,yid,zid,tid
+      real*4 zdtvr,ziadvtrac
+      real adv(1), dtv(1)
+
+      integer ncidf,ncidfv
+      integer varidpu,varidpv,varidt,varidw,varidps,varidph,varidai
+      integer varidpl,varidm
+      integer varidnlo,varidnla,varidnlov,varidnlav
+      save ncidf,ncidfv
+      save varidpu,varidpv,varidt,varidw,varidps,varidph,varidai
+      save varidpl,varidm
+      save varidnlo,varidnla,varidnlov,varidnlav
+
+      real*4 pl(nlevnc)
+
+      integer start(4),count(4),status
+
+      real rcode
+	
+      character namedim	
+	
+c ---------------------------------------------
+c   Initialisation de la lecture des fichiers
+c ---------------------------------------------
+
+      if (irec .eq. 0) then
+
+            ncidf=NCOPN('fluxstoke.nc',NCNOWRIT,rcode)
+
+            varidps=NCVID(ncidf,'phis',rcode)
+            print*,'ncidf,varidps',ncidf,varidps
+
+            varidpl=NCVID(ncidf,'sig_s',rcode)
+            print*,'ncidf,varidpl',ncidf,varidpl
+	
+	    varidnlo=NCVID(ncidf,'nav_lon',rcode)
+            print*,'ncidf,varidnlo',ncidf,varidnlo
+          
+            varidnla=NCVID(ncidf,'nav_lat',rcode)
+            print*,'ncidf,varidnla',ncidf,varidnla
+	
+            varidai=NCVID(ncidf,'aire',rcode)
+            print*,'ncidf,varidai',ncidf,varidai
+         
+            varidm=NCVID(ncidf,'masse',rcode)
+            print*,'ncidf,varidm',ncidf,varidm
+
+            varidpu=NCVID(ncidf,'pbaru',rcode)
+            print*,'ncidf,varidpu',ncidf,varidpu
+		
+            varidw=NCVID(ncidf,'w',rcode)
+            print*,'ncidf,varidw',ncidf,varidw
+	
+	    varidt=NCVID(ncidf,'teta',rcode)
+            print*,'ncidf,varidt',ncidf,varidt
+ 
+	    varidph=NCVID(ncidf,'phi',rcode)
+            print*,'ncidf,varidph',ncidf,varidph
+	
+	    ncidfv=NCOPN('fluxstokev.nc',NCNOWRIT,rcode)
+
+            varidpv=NCVID(ncidfv,'pbarv',rcode)
+            print*,'ncidfv,varidpv',ncidfv,varidpv
+	
+	    varidnlov=NCVID(ncidfv,'nav_lon',rcode)
+            print*,'ncidf,varidnlov',ncidf,varidnlov
+          
+            varidnlav=NCVID(ncidfv,'nav_lat',rcode)
+            print*,'ncidfv,varidnlav',ncidfv,varidnlav
+	
+
+c ID pour les dimensions
+	
+	    status = nf_inq_dimid(ncidf,'y',yid)
+            status = nf_inq_dimid(ncidf,'x',xid)
+            status = nf_inq_dimid(ncidf,'sig_s',zid) 
+            status = nf_inq_dimid(ncidf,'time_counter',tid)
+
+c lecture des dimensions
+	
+	    status = nf_inq_dim(ncidf,yid,namedim,ncjm)
+            status = nf_inq_dim(ncidf,xid,namedim,ncim)
+            status = nf_inq_dim(ncidf,zid,namedim,nclm)
+            status = nf_inq_dim(ncidf,tid,namedim,ncrec)
+	
+	    zjm=ncjm
+            zim=ncim
+            zlm=nclm
+            zrec=ncrec
+	
+	    write(*,*) 'read_fstoke : zrec = ', zrec
+            write(*,*) 'read_fstoke : zlm = ', zlm
+            write(*,*) 'read_fstoke : zim = ', zim
+            write(*,*) 'read_fstoke : zjm = ', zjm
+
+c niveaux de pression
+        
+#ifdef NC_DOUBLE
+       status=NF_GET_VARA_DOUBLE(ncidf,varidpl,1,zlm,pl)
+#else
+       status=NF_GET_VARA_REAL(ncidf,varidpl,1,zlm,pl)
+#endif
+
+c rlonu,rlonv,rlatu,rlatv
+	
+      start(1)=1
+      start(2)=1
+      start(3)=1
+      start(4)=0
+
+      count(1)=zim
+      count(2)=zjm
+      count(3)=1
+      count(4)=0
+	
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidnlo,start,count,rlonu_dy)
+      status=NF_GET_VARA_DOUBLE(ncidf,varidnla,start,count,rlatu_dy)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidnlo,start,count,rlonu_dy)
+      status=NF_GET_VARA_REAL(ncidf,varidnla,start,count,rlatu_dy)
+#endif
+
+      start(1)=1
+      start(2)=1
+      start(3)=1
+      start(4)=0
+
+      count(1)=zim
+      count(2)=zjm-1
+      count(3)=1
+      count(4)=0
+
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidfv,varidnlov,start,count,rlonv_dy)
+      status=NF_GET_VARA_DOUBLE(ncidfv,varidnlav,start,count,rlatv_dy)
+#else
+      status=NF_GET_VARA_REAL(ncidfv,varidnlov,start,count,rlonv_dy)
+      status=NF_GET_VARA_REAL(ncidfv,varidnlav,start,count,rlatv_dy)
+#endif
+
+c Lecture de phis et aire
+	
+      start(1)=1
+      start(2)=1
+      start(3)=1
+      start(4)=0
+
+      count(1)=zim
+      count(2)=zjm
+      count(3)=1
+      count(4)=0
+
+c phis
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidps,start,count,phis)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidps,start,count,phis)
+#endif
+
+c aire
+#ifdef NC_DOUBLE
+       status=NF_GET_VARA_DOUBLE(ncidf,varidai,start,count,airedy)
+#else
+       status=NF_GET_VARA_REAL(ncidf,varidai,start,count,airedy)
+#endif
+
+       else 
+
+      print*,'ok1'
+
+c ---------------------
+c   lecture des champs 
+c ---------------------
+
+      print*,'WARNING!!! Il n y a pas de test de coherence'
+      print*,'sur le nombre de niveaux verticaux dans le fichier nc'
+
+      start(1)=1
+      start(2)=1
+      start(3)=1
+      start(4)=irec
+
+      count(1)=zim
+      count(2)=zjm
+      count(3)=zlm
+      count(4)=1
+
+c masse 
+	PRINT*,'LECTURE DE masse'
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidm,start,count,masse)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidm,start,count,masse)
+#endif
+
+c pbaru 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidpu,start,count,pbaru)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidpu,start,count,pbaru)
+#endif
+
+c w 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidw,start,count,w)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidw,start,count,w)
+#endif
+
+c teta 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidt,start,count,teta)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidt,start,count,teta)
+#endif
+
+c phi 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidf,varidph,start,count,phi)
+#else
+      status=NF_GET_VARA_REAL(ncidf,varidph,start,count,phi)
+#endif
+	
+	count(2) = zjm-1 
+
+c  pbarv
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidfv,varidpv,start,count,pbarv)
+#else
+      status=NF_GET_VARA_REAL(ncidfv,varidpv,start,count,pbarv)
+#endif
+
+      start(3)=irec
+      start(4)=0
+      count(2)=jjp1
+      count(3)=1
+      count(4)=0
+
+	endif
+
+      return
+      end
